#!/bin/bash
#pupchecksum.sh
#01micko 120731 GPL2 (see /usr/share/doc/legal)
#gtkdialog checksum checker
# shinobar: accept paramater
# don570 and shinobar: fix spaces in path name, BASEDIR, more message
#set -x #debug
# version 0.7 dec 7 2012
#+ modified  to use Xdialog (for greater compatibility) by don570
# version 0.9 dec 19 2012  - save of md5sum to file possible
# version 1.0 dec 20  yaf-spash when saving  -save file use \t
#gettext version 1.1  German French  Spanish
#gettext version 1.2 - fixed bug in save 

MYPATH=$0
MYNAME=$(basename "$0")      
VERSION=1.2

CREDIT="$MYNAME - checksum checker: version $VERSION"
usage() {
  echo $CREDIT
  echo "usage: $APPNAME [FILENAME]"
}
case "$1" in
-v|--version) echo $CREDIT; exit ;;
-*) usage; exit;;
esac
export ENT1="$1"
export ENT2=""
rm -f /tmp/pupchecksum*
BASEDIR=$(dirname "$ENT1")
[ -d "$BASEDIR" ] || BASEDIR=""
[ -d "$ENT1" ] && BASEDIR="$ENT1"
[ "$BASEDIR" ] || BASEDIR=$HOME
[ "$BASEDIR" ] || BASEDIR="/root"

export TEXTDOMAIN=pupmd5sum.sh
export OUTPUT_CHARSET=UTF-8
TITLE="pupmd5sum"

#splash screens
export SPLASH1=$(gettext "Please enter a file!")
export _NOFILE=$(gettext "The source file not found!")
export _NGFILE=$(gettext "The source is not a file!")
export _NULL=$(gettext "The source file is null!")
export SPLASH2=$(gettext "Nothing to compare!")
export SPLASH3=$(gettext "Your checksums match")
export SPLASH4=$(gettext "Your checksums DO NOT match")
export SPLASH5=$(gettext "Please wait ...")
export SPLASHT1=$(gettext "Correct")
export SPLASHT2=$(gettext "Wrong!")
export SPLASHT3=$(gettext "Please complete the settings. ")
export SPLASHT4=$(gettext "Saving to disk ...")

#frames, buttons and tool-tip
FRAME1=$(gettext "File Name")
FRAME1a=$(gettext "Hash type")
FRAME2=$(gettext "Checksum")
FRAME3=$(gettext "Compare")
FRAME4=$(gettext "Save Directory")
BTN1=$(gettext "Calculate")
BTN2=$(gettext "Compare")
BTN4=$(gettext "OK")
BTN5=$(gettext "Select a Directory to save MD5sum")
TT=$(gettext "Paste the correct checksum here")
SAVETT=$(gettext "MD5sum is saved to a text file")

#Save to file
#Check func


checkfunc()
{

	CHECKSUM=md5sum
	[ "$RB2" = "true" ] && CHECKSUM=sha1sum
	ERRMSG=""
	[ "$ENT1" ] || ERRMSG=$SPLASH1
	[ -s "$ENT1" ] || ERRMSG=$_NULL
	[ -f "$ENT1" ] || ERRMSG=$_NGFILE
	[ -e "$ENT1" ] || ERRMSG=$_NOFILE
	if [ "$ERRMSG" ] ; then
	Xdialog  --ok-label "$BTN4" --backtitle "\n\n   $ERRMSG    "  --msgbox  "" 0 0
	  return 1
	fi
		Xdialog  --ok-label "$BTN4" --backtitle "\n\n    $SPLASH5    "  --msgbox  "" 0 0 &

	SPID=$!
	$CHECKSUM "$ENT1" > /tmp/pupchecksum
	ENT=$(cat /tmp/pupchecksum)
	rm /tmp/pupchecksum
	export ENT2=${ENT%% *}	#fix dirname with spaces
	echo $ENT2 > /tmp/pupchecksum_result
	kill $SPID
}
export -f checkfunc
 
# check md5sum for length and if foldername supplied then create file to save md5 sum
checkmd5sum()
{	
export RESULT=`cat /tmp/pupchecksum_result`
if  [ ${#RESULT} -eq 32 ]  && [ -n  "$FILE_DIRECTORY" ]; then  # save the md5sum
break
elif [ ${#RESULT} -ne 32 ] || [ ! -e /tmp/pupchecksum_folder  ];then  # don't save
		Xdialog  --ok-label "$BTN4" --backtitle "\n\n    $SPLASHT2    "  --msgbox  "\n     $SPLASHT3   \n " 0 0 &
exit 0
fi
 yaf-splash -timeout 2 -border false  -center -close never -bg orange -fontsize large -text "
  $SPLASHT4   
   "  &
cd "$FILE_DIRECTORY"
#FILENAME="$(basename $ENT1)"   won't work
FILENAME="${ENT1##*/}" # find ending of pathname
echo -e "$RESULT\t$FILENAME" > "$FILENAME".md5.txt

exit 0



}
export -f checkmd5sum








#compare
comparefunc()
{
	CHECKSUM=md5sum
	[ "$RB2" = "true" ] && CHECKSUM=sha1sum
	if [ ! "$ENT2" -o ! "$ENT3" ];then Xdialog  --ok-label "$BTN4" --backtitle "\n\n    $SPLASH2    "  --msgbox  "" 0 0
	 else
	 #ENT3=$(echo -n "$ENT3"|sed 's/ //g') #remove whitespace with bad copy/paste
	 ENT3=$(echo $ENT3)	#remove whitespace with bad copy/paste
	 ENT3=${ENT3%% *}	# extract only the checksum
	[ "$ENT2" = "$ENT3" ] && Xdialog  --ok-label "$BTN4" --backtitle "\n\n   ${CHECKSUM}: $SPLASH3    " \
	 --msgbox  "" 0 0 || Xdialog  --ok-label "$BTN4" --backtitle "\n\n    ${CHECKSUM}: $SPLASH4    "  --msgbox  "" 0 0
	fi
}
export -f comparefunc

export MAINGUI='<window  title="'"$TITLE"'-'"$VERSION"'" icon-name="hash" resizable="false">
 <hbox>
  <vbox width-request="335">
   <frame '"$FRAME1"'>
    <hbox>
     <entry fs-action="file" fs-folder="'"$BASEDIR"'">
      <variable>ENT1</variable>
      <default>"'$ENT1'"</default>
      <action>clear:ENT2</action>
     </entry>
     <button>
	  <input file stock="gtk-new"></input>
	  <action>fileselect:ENT1</action>
	 </button>
	</hbox>
   </frame>
   <frame '"$FRAME1a"'>
    <hbox homogeneous="true">
     <radiobutton>
       <label>MD5</label>
       <variable>RB1</variable>
     </radiobutton>
     <radiobutton>
       <label>Sha-1</label>
       <variable>RB2</variable>
     </radiobutton>
    </hbox>
   </frame>
   <frame '"$FRAME2"'>
    <entry  tooltip-text=" '"$(gettext 'Result of calculation')"' ">
     <variable>ENT2</variable>
     <input>cat /tmp/pupchecksum_result 2>/dev/null</input>
    </entry>
   </frame>
   <frame '"$FRAME3"'>
    <entry tooltip-text="'"$TT"'">
     <variable>ENT3</variable>
    </entry>
   </frame>
   
   
   
   
<frame '"$FRAME4"'>
			<hbox>
				<entry accept="directory" tooltip-text=" '"$SAVETT"' ">
					<label>'"$BTN5"')</label>
					<variable>FILE_DIRECTORY</variable>
				</entry>
				<button>
					<input file stock="gtk-open"></input>
					<action type="fileselect">FILE_DIRECTORY</action>
					<action>touch  /tmp/pupchecksum_folder</action>
				</button>
			</hbox>
		</frame>  </vbox>
		
		
		
		
		
  <vbox  space-expand="true" width-request="150">
   <hbox>
    <frame>
     <pixmap>
      <width>48</width>
      <input file>/usr/share/pixmaps/hash.xpm</input>
     </pixmap>
    </frame>
   </hbox>      <text height-request="30"><label> </label></text>

   <hbox space-expand="true" space-fill="true">
    <button homogeneous="true">
     <input file>/usr/share/pixmaps/puppy/calculator.svg</input>
     <height>24</height>
     <label>'"$BTN1"'</label>
     <action>checkfunc '"$ENT1"'</action>
     <action type="refresh">ENT2</action>
    </button>
   </hbox>
   <hbox space-expand="true" space-fill="true">
    <button homogeneous="true">
     <input file stock="gtk-refresh"></input>
     <label>'"$BTN2"'</label>
     <action>comparefunc</action>
     </button>
   </hbox>
    <hbox space-expand="true" space-fill="true">
    
      <button tooltip-text=" '"$SAVETT"' " homogeneous="true">
      <input file stock="gtk-save"></input>
      <label>'"$(gettext "Save")"'</label>
      <action>checkmd5sum</action>
    </button>
     
    
   </hbox>
   <hbox space-expand="true" space-fill="true">
   
   <button homogeneous="true">
      <input file stock="gtk-close"></input>
      <label>'$(gettext "Close")'</label>
      <action type="exit">CLOSE</action>
    </button>
   </hbox>
  </vbox>
 </hbox>
</window>'
for P in gtkdialog4 gtkdialog3 gtkdialog; do
  GTKDIALOG=$(which $P) && break
done
if [ -z "$GTKDIALOG" ]; then
  echo "$MYNAME: error: gtkdialog not found." >&2
  exit 1
fi
[ -f "$ENT1" -a -s "$ENT1" ] && checkfunc "$ENT1"
$GTKDIALOG -p MAINGUI  --geometry=+200+100
unset MAINGUI
